<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesSSCN_RF_2 extends Record {
    public $name = "spc";
    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "inf",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "bloco",
            'position' => 11,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "desc_situacao_RF",
            'position' => 13,
            'size' => 30,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data_situacao",
            'position' => 43,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "participa_simples",
            'position' => 51,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data_consulta_RF",
            'position' => 52,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "expansao",
            'position' => 60,
            'size' => 56,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['inf'] = substr($values, 8, 2);
        $newValues['bloco'] = substr($values, 10, 2);
        $newValues['desc_situacao_RF'] = substr($values, 12, 30);
        $newValues['data_situacao'] = substr($values, 42, 8);
        $newValues['participa_simples'] = substr($values, 50, 1);
        $newValues['data_consulta_RF'] = substr($values, 51, 8);
        $newValues['expansao'] = substr($values, 59, 56);
        
        $this->setValues($newValues);
    }
}