<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN250_00 extends Record{
    public $name = "national_protest";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_ocor",
            'position' => 7,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tp_moeda",
            'position' => 15,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "value",
            'position' => 18,
            'size' => 15,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cartorio",
            'position' => 33,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "city",
            'position' => 35,
            'size' => 30,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 65,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 67,
            'size' => 49,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['dt_ocor'] = substr($values, 6, 8);
        $newValues['tp_moeda'] = substr($values, 14, 3);
        $newValues['value'] = substr($values, 17, 15);
        $newValues['cartorio'] = substr($values, 32, 2);
        $newValues['city'] = substr($values, 34, 30);
        $newValues['uf'] = substr($values, 64, 2);
        $newValues['filler'] = substr($values, 66, 49);
        
        $this->setColumnsValues($newValues);
    }
}