<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN270_90 extends Record{
    public $name = "total_bad_check";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tot_ocor",
            'position' => 7,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_ocor_antiga",
            'position' => 12,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_ocor_recente",
            'position' => 20,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "bco",
            'position' => 28,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "agency",
            'position' => 31,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "fantasy_name",
            'position' => 35,
            'size' => 12,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 47,
            'size' => 69,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['tot_ocor'] = substr($values, 6, 5);
        $newValues['dt_ocor_antiga'] = substr($values, 11, 8);
        $newValues['dt_ocor_recente'] = substr($values, 19, 8);
        $newValues['bco'] = substr($values, 27, 3);
        $newValues['agency'] = substr($values, 30, 4);
        $newValues['fantasy_name'] = substr($values, 34, 12);
        $newValues['filler'] = substr($values, 46, 69);
        
        $this->setColumnsValues($newValues);
    }   
}