<?php

namespace Schaffen\SerasaRemessa\Http\Basic\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegN003  extends Record {
    protected $templateColumns = [
        [
            'name' => "tipo_reg", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 1,
            'size' => 4
        ],
        [
            'name' => "subtp", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 5,
            'size' => 2
        ],
        [
            'name' => "ddd", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 7,
            'size' => 4
        ],
        [
            'name' => "telefone", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 11,
            'size' => 8
        ],
        [
            'name' => "cep", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 19,
            'size' => 9
        ],
        [
            'name' => "filler", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 28,
            'size' => 2
        ],
        [
            'name' => "feat_scor", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 30,
            'size' => 4
        ],
        [
            'name' => "blank_1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 34,
            'size' => 82
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();

        if($values !== null) {
            $this->setValues($values);
        }
    }

    private function setValues($values) {
        $values['tipo_reg'] = "N003";
        $values['subtp'] = "00";
        $values['ddd'] = "";
        $values['telefone'] = "";
        $values['cep'] = "";
        $values['filler'] = "SP";
        $values['feat_scor'] = "RXPS";
        $values['blank_1'] = "";

        $this->setColumnsValues($values);
    }
}